{
  "openapi": "3.0.0",
  "info": {
    "description": "## Introduction\n\nIBM Cloud® Internet Services (CIS), powered by Cloudflare, provides a fast, highly performant, reliable, and secure internet service for customers running their business on IBM Cloud.\n\nCIS gets you going quickly by establishing defaults for you, which you can change by using the API or UI. Here are some commonly changed parameters:\n\n* **DNS settings**: you can use CIS to host your DNS or you can create CNAME records.\n* **Crypto settings (TLS)**: the default is flexible mode, which encrypts the connection between your host and the CIS edge server, but does not encrypt the communication between the CIS edge server and origin server.\n\nFor complete information about establishing and managing an IBM Cloud Internet Services instance, refer to [our customer documentation](https://cloud.ibm.com/docs/cis?topic=cis-getting-started#getting-started).\n\nThe code examples on this tab use the CIS Python SDK.\n\nInstallation\n\n```bash\npip install --upgrade \"ibm-networking-services\"\n```\n\nGitHub\n\nhttps://github.com/IBM/networking-python-sdk\n\nThe code examples on this tab use the CIS Go SDK.\n\nInstallation\n\n```bash\ngo get -u github.com/IBM/networking-go-sdk\n```\n\nGitHub\n\nhttps://github.com/IBM/networking-go-sdk\n\nThe code examples on this tab use the CIS Node SDK.\n\nInstallation\n```bash\nnpm install ibm-networking-services\n```\n\nGitHub\n\nhttps://github.com/IBM/networking-node-sdk\n\nThe code examples on this tab use the client library that is provided for Java.\n\nMaven\n\n```xml\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>firewall-access-rules</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>caching-api</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>custom-pages</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>dns-records</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>dns-records-bulk</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>firewall-api</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>global-load-balancer</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>global-load-balancer-pool</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>global-load-balancer-monitor</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>global-load-balancer-events</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>cis-ip-api</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>zone-rate-limits</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>routing</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>ssl-certificate-api</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>security-events-api</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>user-agent-blocking-rules</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>waf-api</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>waf-rule-groups-api</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>waf-rule-packages-api</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>waf-rules-api</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>zones</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>zone-lockdown</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>zone-firewall-access-rules</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>zones-settings</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n        <dependency>\n            <groupId>${project.groupId}</groupId>\n            <artifactId>cis-range-applications</artifactId>\n            <version>${project.version}</version>\n        </dependency>\n```\n\nGradle:\n\n```sh\ncompile 'com.ibm.cloud:firewall-access-rules:X.X.X'\ncompile 'com.ibm.cloud:caching-api:X.X.X'\ncompile 'com.ibm.cloud:custom-pages:X.X.X'\ncompile 'com.ibm.cloud:dns-records:X.X.X'\ncompile 'com.ibm.cloud:dns-records-bulk:X.X.X'\ncompile 'com.ibm.cloud:firewall-api:X.X.X'\ncompile 'com.ibm.cloud:global-load-balancer:X.X.X'\ncompile 'com.ibm.cloud:global-load-balancer-pool:X.X.X'\ncompile 'com.ibm.cloud:global-load-balancer-monitor:X.X.X'\ncompile 'com.ibm.cloud:global-load-balancer-events:X.X.X'\ncompile 'com.ibm.cloud:cis-ip-api:X.X.X'\ncompile 'com.ibm.cloud:zone-rate-limits:X.X.X'\ncompile 'com.ibm.cloud:routing:X.X.X'\ncompile 'com.ibm.cloud:ssl-certificate-api:X.X.X'\ncompile 'com.ibm.cloud:security-events-api:X.X.X'\ncompile 'com.ibm.cloud:user-agent-blocking-rules:X.X.X'\ncompile 'com.ibm.cloud:waf-api:X.X.X'\ncompile 'com.ibm.cloud:waf-rule-groups-api:X.X.X'\ncompile 'com.ibm.cloud:waf-rule-packages-api:X.X.X'\ncompile 'com.ibm.cloud:waf-rules-api:X.X.X'\ncompile 'com.ibm.cloud:zones:X.X.X'\ncompile 'com.ibm.cloud:zone-lockdown:X.X.X'\ncompile 'com.ibm.cloud:zone-firewall-access-rules:X.X.X'\ncompile 'com.ibm.cloud:zones-settings:X.X.X'\ncompile 'com.ibm.cloud:cis-range-applications:X.X.X'\n```\n\nGitHub\n\n[https://github.com/IBM/networking-java-sdk](https://github.com/IBM/networking-java-sdk)\n\n## Endpoint URL\n\nThe CIS API uses the following global endpoint URL for all regions. When you call the API, add the path for each method to form the complete API endpoint for your requests.\n\nThe public endpoint is protected by Cloudflare; TLS termination occurs for all incoming traffic at the edge.\n\n```python\nhttps://api.cis.cloud.ibm.com\n```\n\n```sh\nhttps://api.cis.cloud.ibm.com\n```\n\n```go\nhttps://api.cis.cloud.ibm.com\n```\n\n```java\nhttps://api.cis.cloud.ibm.com\n```\n## API rate limiting\n\nBy default, the CIS API is rate limited at 100 requests in under a minute. There are some exceptions to this limit, including the Logpush ownership challenge which is rate limited at 5 requests in under a minute.\n\n## Error handling\n\nThis API uses standard HTTP response codes to indicate whether a method completed successfully. A `200` response always indicates success. A `400` type response is some sort of failure, and a `500` type response usually indicates an internal system error.\n\n| HTTP error code | Description | Recovery |\n|-----------------|-------------|----------|\n| `200` | Success | The request was successful. |\n| `400` | Bad Request | The input parameters in the request body are either incomplete or in the wrong format. Be sure to include all required parameters in your request. |\n| `401` | Unauthorized | You are not authorized to make this request. Log in to IBM Cloud and try again. If this error persists, contact the account owner to check your permissions.|\n| `403` | Forbidden | The supplied authentication is not authorized to access '{namespace}'. |\n| `404` | Not Found | The requested resource could not be found. |\n| `408` | Request Timeout | The connection to the server timed out. Wait a few minutes, then try again. |\n| `409` | Conflict | The entity is already in the requested state. |\n| `500` | Internal Server Error | IBM Cloud Internet Services is currently unavailable. Your request could not be processed. Wait a few minutes and try again. |\n\nHere are some model code examples for error handling in the IBM Cloud Internet Services API:\n\n```sh\n200 The API was completed successfully\n\n{\n  \"success\": true,\n  \"errors\": [\n    {}\n  ],\n  \"messages\": [\n    {}\n  ],\n  \"result\": {\n    \"zones\": [\n      {\n        \"zone\": {\n          \"status\": null,\n          \"name\": null,\n          \"security\": null,\n          \"paused\": false\n        },\n        \"dns_record\": {\n          \"count\": 0\n        },\n        \"load_balancer\": {\n          \"monitor_count\": 0,\n          \"pool_count\": 0,\n          \"load_balancer_active_count\": 0\n        },\n        \"caching\": {\n          \"edge_cache_ttl\": 0,\n          \"cache_browser_ttl\": 0,\n          \"development_mode\": \"off\",\n          \"cache_level\": \"basic\"\n        },\n        \"pagerule\": {\n          \"active_count\": 0,\n          \"inactive_count\": 0\n        },\n        \"waf\": {\n          \"status\": null\n        },\n        \"ssl\": {\n          \"mode\": null,\n          \"universal_ssl_certificate\": \"off\",\n          \"dedicate_certificate_count\": 0,\n          \"custom_upload_certificate_count\": 0,\n          \"tls_1_2_only\": \"on\"\n        },\n        \"plan_details\": {\n          \"plan_name\": \"Standard\",\n          \"days_remaining\": null\n        },\n        \"firewall\": {\n          \"security_level\": \"low\"\n        }\n      }\n    ],\n    \"service_maintenance\": {\n      \"start_time\": null,\n      \"end_time\": null,\n      \"message\": null\n    }\n  }\n}\n```\n\n```sh\n401 Action unauthorized\n\n{\n  \"trace\": \"be45687c-57f2-46e8-8717-32b3153a5886\",\n  \"errors\": [\n    {\n      \"code\": 401,\n      \"message\": \"Action is not authorized.\"\n    }\n  ]\n}\n```\n\n```sh\n404 API not found\n{\n  \"trace\": \"c3c9f6af-a20f-4b73-8e3d-800a9284a07f\",\n  \"errors\": [\n    {\n      \"code\": null,\n      \"message\": \"404 Not Found\"\n    }\n  ]\n}\n```\n\n## Authentication\n\nThe CIS API uses Identity and Access Management (IAM) to authenticate requests. Pass a bearer token in an Authorization header. Tokens support authenticated requests without embedding service credentials in every call. Learn more about [IAM](https://cloud.ibm.com/docs/account?topic=account-iamoverview).\n\nTo call each method, you'll need to be assigned a role that includes the required IAM actions. Each method lists the associated action. For more information about IAM actions and how they map to roles, see [Managing access for CIS](https://cloud.ibm.com/docs/cis?topic=cis-iam-and-cis#iam-and-cis).\n\n## Event tracking\n\nYou can monitor API activity within your account by using the IBM Cloud Activity Tracker service. Whenever an API method is called, an event is generated that you can then track and audit from within Activity Tracker. The specific event type is listed for each individual method. \n\nFor more information about how to track CIS activity, see [Auditing events for CIS](https://cloud.ibm.com/docs/cis?topic=cis-at_events#at_events).\n\nFor more information about IAM actions and Activity Tracker actions by API method, see [IAM and Activity Tracker actions by API](https://cloud.ibm.com/docs/cis?topic=cis-at_iam_CIS#at_iam_CIS).",
    "version": "1.0.0",
    "title": "Cloud Internet Services API",
    "contact": {
      "name": "CIS Developers",
      "email": "CIS-Support-Squad@wwpdl.vnet.ibm.com"
    },
    "x-github": "https://github.ibm.com/cloud-api-docs/cloud-internet-services",
    "x-github-issues": "https://github.ibm.com/cloud-api-docs/cloud-internet-services/issues/new",
    "x-last-updated": "2026-06-02"
  },
  "servers": [
    {
      "url": "https://api.cis.cloud.ibm.com"
    }
  ],
  "security": [
    {
      "iamToken": []
    }
  ],
  "tags": [
    {
      "name": "Advanced Certificate Pack",
      "description": "Advanced Certificate Pack for a given zone."
    },
    {
      "name": "Alert Policies",
      "description": "View and Adjust Alert Policies for your CIS Instance."
    },
    {
      "name": "Alert Webhooks",
      "description": "View and Adjust Alert Webhooks for your CIS Instance."
    },
    {
      "name": "Zone-Level Authenticated Origin Pull",
      "description": "Setup authenticated origin pull for a given zone."
    },
    {
      "name": "Per-hostname Authenticated Origin Pull",
      "description": "Setup a client certificate per hostname to be sent in a request to Origin."
    },
    {
      "name": "Bot Analytics",
      "description": "Bot Analytics for a given zone."
    },
    {
      "name": "Bot Management Settings",
      "description": "Bot Management for a given zone."
    },
    {
      "name": "Cache Settings",
      "description": "Cache settings and Purging caches."
    },
    {
      "name": "Custom Pages",
      "description": "Custom pages for a given instance."
    },
    {
      "name": "DNS Records",
      "description": "DNS records for a service instance."
    },
    {
      "name": "Edge Functions Actions",
      "description": "Edge functions actions for a given instance."
    },
    {
      "name": "Edge Functions Triggers",
      "description": "Edge functions triggers for a given zone."
    },
    {
      "name": "Filters",
      "description": "Filters for a zone"
    },
    {
      "name": "Firewall Event Analytics",
      "description": "Firewall event analytics data."
    },
    {
      "name": "Firewall rules",
      "description": "Firewall rules for a zone"
    },
    {
      "name": "Global Load Balancer",
      "description": "Global load balancers for a given zone."
    },
    {
      "name": "Global Load Balancer Events",
      "description": "Get load balancer events for all origins."
    },
    {
      "name": "Global Load Balancer Monitor",
      "description": "Global load balancer monitor for a user."
    },
    {
      "name": "Global Load Balancer Pool",
      "description": "Global load balancer pools."
    },
    {
      "name": "Instance Level Firewall Access Rules",
      "description": "Instance level firewall access rules."
    },
    {
      "name": "Instance Rulesets",
      "description": "Instance level Rulesets."
    },
    {
      "name": "Instant Logs",
      "description": "Instant logs jobs for a zone."
    },
    {
      "name": "IP Allowlist",
      "description": "List of all IP addresses used by the CIS proxy."
    },
    {
      "name": "Lists",
      "description": "View and Manage Lists for your domain."
    },
    {
      "name": "Logpush Jobs",
      "description": "View and Manage Logpush Jobs for your domain."
    },
    {
      "name": "Logs RayID",
      "description": "View events from a given RayID."
    },
    {
      "name": "Mutual TLS",
      "description": "Mutual TLS for a zone."
    },
    {
      "name": "Origin Certificate",
      "description": "Origin certificate for a given zone."
    },
    {
      "name": "Page Rules",
      "description": "A rule describing target patterns for requests and actions to perform on matching requests."
    },
    {
      "name": "Range Analytics",
      "description": "Range Analytics inside a zone."
    },
    {
      "name": "Range Applications",
      "description": "Range Applications inside a zone."
    },
    {
      "name": "Routing",
      "description": "Get smart route setting for a given zone."
    },
    {
      "name": "Security Level Setting (DEPRECATED)",
      "description": "Security-level setting for a given zone."
    },
    {
      "name": "Edge Certificate",
      "description": "SSL certificate for a given zone."
    },
    {
      "name": "Total TLS",
      "description": "Configuring Total TLS for a given zone."
    },
    {
      "name": "User-Agent Blocking Rules",
      "description": "User agent blocking rules."
    },
    {
      "name": "Zone Firewall Access Rules",
      "description": "Firewall access rules for a zone."
    },
    {
      "name": "Zone Hold",
      "description": "Zone Hold for a given zone."
    },
    {
      "name": "Zone Lockdown Rules",
      "description": "Lockdown rules for a zone."
    },
    {
      "name": "Zone Rate Limits",
      "description": "Rate limits for a zone."
    },
    {
      "name": "Zone Rulesets",
      "description": "Zone level Rulesets."
    },
    {
      "name": "Zones",
      "description": "Zones for a service instance (currently only one zone creation allowed per instance)"
    },
    {
      "name": "Zones Settings",
      "description": "Zone setting for a given zone."
    },
    {
      "name": "Security Events (DEPRECATED)",
      "description": "Logs of the mitigation performed by Firewall features."
    },
    {
      "name": "WAF settings (previous)",
      "description": "A Web Application Firewall (WAF) blocks requests that contain malicious content."
    },
    {
      "name": "WAF Rule Groups (DEPRECATED)",
      "description": "WAF rule groups contained within a package."
    },
    {
      "name": "WAF Rule Packages (DEPRECATED)",
      "description": "Web Application Firewall (WAF) rule packages are collections of rule groups."
    },
    {
      "name": "WAF Rules (DEPRECATED)",
      "description": "Web Application Firewall (WAF) rules."
    }
  ],
  "paths": {
    "/v1/{crn}/rulesets": {
      "get": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "List Instance rulesets",
        "operationId": "get_instance_rulesets",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets.read"
            }
          ]
        },
        "description": "List all rulesets at the instance level.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/list_rulesets_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/rulesets/{ruleset_id}": {
      "get": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Get an instance ruleset",
        "operationId": "get_instance_ruleset",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets.read"
            }
          ]
        },
        "description": "View a specific instance ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ruleset_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "put": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Update an instance ruleset",
        "operationId": "update_instance_ruleset",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.manage"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rules.update"
            }
          ]
        },
        "description": "Update a specific instance ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ruleset_update"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ruleset_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X PUT \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\\\n",
                      "  -d '{\"description\":\"My ruleset to execute managed rulesets\",\"kind\":\"root\",\"name\":\"My ruleset\",\"phase\":\"http_request_firewall_custom\",\"rules\":[{\"action\":\"block\",\"action_parameters\":{\"response\":{\"content\":\"{\\n  \\\"success\\\": false,\\n  \\\"error\\\": \\\"you have been blocked\\\"\\n}\",\"content_type\":\"application/json\",\"status_code\":400}},\"description\":\"Block when the IP address is not 1.1.1.1\",\"enabled\":true,\"expression\":\"ip.src ne 1.1.1.1\",\"id\":\"3a03d665bac047339bb530ecb439a90d\",\"logging\":{\"enabled\":true},\"ref\":\"my_ref\"}]}'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "delete": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Delete an instance ruleset",
        "operationId": "delete_instance_ruleset",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.manage"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets.delete"
            }
          ]
        },
        "description": "Delete a specific instance ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          }
        ],
        "responses": {
          "204": {
            "description": "Success"
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X DELETE \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/rulesets/{ruleset_id}/versions": {
      "get": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "List version of an instance ruleset",
        "operationId": "get_instance_ruleset_versions",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-versions.read"
            }
          ]
        },
        "description": "List all versions of a specific instance ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/list_rulesets_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID/versions \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/rulesets/{ruleset_id}/versions/{ruleset_version}": {
      "get": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Get a specific version of an instance ruleset",
        "operationId": "get_instance_ruleset_version",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-versions.read"
            }
          ]
        },
        "description": "View a specific version of a specific instance ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          },
          {
            "$ref": "#/components/parameters/ruleset_version"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ruleset_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID/versions/$RULESET_VERSION \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "delete": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Delete a specific version of an instance ruleset",
        "operationId": "delete_instance_ruleset_version",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.manage"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-versions.delete"
            }
          ]
        },
        "description": "Delete a specific version of a specific instance ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          },
          {
            "$ref": "#/components/parameters/ruleset_version"
          }
        ],
        "responses": {
          "204": {
            "description": "Success"
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X DELETE \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID/versions/$RULESET_VERSION \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/rulesets/phases/{ruleset_phase}/entrypoint": {
      "get": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Get an instance entrypoint ruleset",
        "operationId": "get_instance_entrypoint_ruleset",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-phases-entrypoint.read"
            }
          ]
        },
        "description": "Get the instance ruleset for the given phase's entrypoint.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_phase"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ruleset_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/phases/$RULESET_PHASE/entrypoint \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "put": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Update an instance entrypoint ruleset",
        "operationId": "update_instance_entrypoint_ruleset",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.manage"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-phases-entrypoint.update"
            }
          ]
        },
        "description": "Updates the instance ruleset for the given phase's entry point.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_phase"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ruleset_update"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ruleset_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X PUT \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/phases/$RULESET_PHASE/entrypoint \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\\\n",
                      "  -d '{\"description\":\"My ruleset to execute managed rulesets\",\"kind\":\"root\",\"name\":\"My ruleset\",\"phase\":\"http_request_firewall_custom\",\"rules\":[{\"action\":\"block\",\"action_parameters\":{\"response\":{\"content\":\"{\\n  \\\"success\\\": false,\\n  \\\"error\\\": \\\"you have been blocked\\\"\\n}\",\"content_type\":\"application/json\",\"status_code\":400}},\"description\":\"Block when the IP address is not 1.1.1.1\",\"enabled\":true,\"expression\":\"ip.src ne 1.1.1.1\",\"id\":\"3a03d665bac047339bb530ecb439a90d\",\"logging\":{\"enabled\":true},\"ref\":\"my_ref\"}]}'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/rulesets/phases/{ruleset_phase}/entrypoint/versions": {
      "get": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "List an instance entry point ruleset's versions",
        "operationId": "get_instance_entry_point_ruleset_versions",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.read"
            }
          ]
        },
        "x-ibm-events": {
          "actions": [
            {
              "name": "internet-svcs.rulesets-phases-entrypoint-versions.read"
            }
          ]
        },
        "description": "Lists the instance ruleset versions for the given phase's entry point.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_phase"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/list_rulesets_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/phases/$RULESET_PHASE/entrypoint/versions \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/rulesets/phases/{ruleset_phase}/entrypoint/versions/{ruleset_version}": {
      "get": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Get an instance entry point ruleset version",
        "operationId": "get_instance_entry_point_ruleset_version",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-phases-entrypoint-versions.read"
            }
          ]
        },
        "description": "Fetches a specific version of an instance entry point ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_phase"
          },
          {
            "$ref": "#/components/parameters/ruleset_version"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ruleset_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/phases/$RULESET_PHASE/entrypoint/versions/$RULESET_VERSION \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/rulesets/{ruleset_id}/rules": {
      "post": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Create an instance ruleset rule",
        "operationId": "create_instance_ruleset_rule",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.manage"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-rules.create"
            }
          ]
        },
        "description": "Create an instance ruleset rule.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/rule_create"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/rule_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X POST \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID/rules \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\\\n",
                      "  -d '{\"action\":\"block\",\"action_parameters\":{\"response\":{\"content\":\"{\\n  \\\"success\\\": false,\\n  \\\"error\\\": \\\"you have been blocked\\\"\\n}\",\"content_type\":\"application/json\",\"status_code\":400}},\"description\":\"Block when the IP address is not 1.1.1.1\",\"enabled\":true,\"expression\":\"ip.src ne 1.1.1.1\",\"id\":\"3a03d665bac047339bb530ecb439a90d\",\"logging\":{\"enabled\":true},\"ref\":\"my_ref\",\"position\":{\"before\":\"da5e8e506c8e7877fe06cdf4c41add54\"}}'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/rulesets/{ruleset_id}/rules/{rule_id}": {
      "patch": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Update an instance ruleset rule",
        "operationId": "update_instance_ruleset_rule",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.manage"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-rules.update"
            }
          ]
        },
        "description": "Update an instance ruleset rule.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          },
          {
            "$ref": "#/components/parameters/rule_id"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/rule_update"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/rule_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X PUT \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID/rules/$RULE_ID \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\\\n",
                      "  -d '{\"action\":\"block\",\"action_parameters\":{\"response\":{\"content\":\"{\\n  \\\"success\\\": false,\\n  \\\"error\\\": \\\"you have been blocked\\\"\\n}\",\"content_type\":\"application/json\",\"status_code\":400}},\"description\":\"Block when the IP address is not 1.1.1.1\",\"enabled\":true,\"expression\":\"ip.src ne 1.1.1.1\",\"id\":\"3a03d665bac047339bb530ecb439a90d\",\"logging\":{\"enabled\":true},\"ref\":\"my_ref\",\"position\":{\"before\":\"da5e8e506c8e7877fe06cdf4c41add54\"}}'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "delete": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "Delete an instance ruleset rule",
        "operationId": "delete_instance_ruleset_rule",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-rules.read"
            }
          ]
        },
        "description": "Delete an instance ruleset rule.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          },
          {
            "$ref": "#/components/parameters/rule_id"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/rule_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X DELETE \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID/rules/$RULE_ID \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/rulesets/{ruleset_id}/versions/{ruleset_version}/by_tag/{rule_tag}": {
      "get": {
        "tags": [
          "Instance Rulesets"
        ],
        "summary": "List an instance ruleset verion's rules by tag",
        "operationId": "get_instance_ruleset_version_by_tag",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.zones.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.rulesets-versions-by-tag.read"
            }
          ]
        },
        "description": "Lists rules by tag for a specific version of an instance ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          },
          {
            "$ref": "#/components/parameters/ruleset_version"
          },
          {
            "$ref": "#/components/parameters/rule_tag"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ruleset_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/rulesets/$RULESET_ID/versions/$RULESET_VERSION/by_tag/$RULE_TAG \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/zones/{zone_identifier}/rulesets": {
      "get": {
        "tags": [
          "Zone Rulesets"
        ],
        "summary": "List zone rulesets",
        "operationId": "get_zone_rulesets",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.security.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.zone-rulesets.read"
            }
          ]
        },
        "description": "List all rulesets at the zone level.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/zone_identifier"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/list_rulesets_resp"
                },
                "examples": {
                  "response": {
                    "value": {
                      "success": true,
                      "errors": [],
                      "messages": [],
                      "result": [
                        {
                          "description": "Created by the CIS security team, this ruleset provides normalization on the URL path",
                          "id": "70339d97bdb34195bbf054b1ebe81f76",
                          "kind": "managed",
                          "last_updated": "2024-08-01T17:37:11.538019Z",
                          "name": "CIS Normalization Ruleset",
                          "phase": "http_request_sanitize",
                          "version": "6"
                        },
                        {
                          "description": "Exposed credentials check rules",
                          "id": "c2e184081120413c86c3ab7e14069605",
                          "kind": "managed",
                          "last_updated": "2024-08-01T17:37:12.291474Z",
                          "name": "CIS Exposed Credentials Check Ruleset",
                          "phase": "http_request_firewall_managed",
                          "version": "89"
                        },
                        {
                          "description": "CIS's implementation of the Open Web Application Security Project (OWASP) ModSecurity Core Rule Set. We routinely monitor for updates from OWASP based on the latest version available from the official code repository",
                          "id": "4814384a9e5d4991b9815dcfc25d2f1f",
                          "kind": "managed",
                          "last_updated": "2024-08-19T17:26:58.593021Z",
                          "name": "CIS OWASP Core Ruleset",
                          "phase": "http_request_firewall_managed",
                          "version": "87"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/zones/$ZONE_ID/rulesets \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "package main\n",
                      "\n",
                      "import (\n",
                      "    \"encoding/json\"\n",
                      "    \"fmt\"\n",
                      "    \"os\"\n",
                      "\n",
                      "    \"github.com/IBM/go-sdk-core/v5/core\"\n",
                      "    \"github.com/IBM/networking-go-sdk/rulesetsv1\"\n",
                      ")\n",
                      "\n",
                      "func main() {\n",
                      "    authenticator := &core.IamAuthenticator{\n",
                      "        ApiKey: os.Getenv(\"CIS_SERVICES_APIKEY\"),\n",
                      "        URL:    os.Getenv(\"CIS_SERVICES_AUTH_URL\"),\n",
                      "    }\n",
                      "\n",
                      "    serviceURL := os.Getenv(\"API_ENDPOINT\")\n",
                      "    crn := os.Getenv(\"CRN\")\n",
                      "    zoneID := os.Getenv(\"ZONE_ID\")\n",
                      "    options := &rulesetsv1.RulesetsV1Options{\n",
                      "        ServiceName:    \"cis_services\",\n",
                      "        URL:            serviceURL,\n",
                      "        Authenticator:  authenticator,\n",
                      "        Crn:            &crn,\n",
                      "        ZoneIdentifier: &zoneID,\n",
                      "    }\n",
                      "\n",
                      "    service, serviceErr := rulesetsv1.NewRulesetsV1(options)\n",
                      "    if serviceErr != nil {\n",
                      "        fmt.Printf(\"Error creating RulesetsV1 service: %v\\n\", serviceErr)\n",
                      "        return\n",
                      "    }\n",
                      "    getRulesetsOptions := service.NewGetZoneRulesetsOptions()\n",
                      "    _, response, err := service.GetZoneRulesets(getRulesetsOptions)\n",
                      "    if err != nil {\n",
                      "        fmt.Printf(\"Error retrieving rulesets: %v\\n\", err)\n",
                      "        return\n",
                      "    }\n",
                      "    fmt.Printf(\"Rulesets: %+v\\n\", response.Result)\n",
                      "}\n"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "require('dotenv').config();\n",
                      "\n",
                      "const RulesetsV1 = require('ibm-networking-services/cis/rulesets/v1');\n",
                      "const { IamAuthenticator } = require('ibm-cloud-sdk-core');\n",
                      "\n",
                      "const options = {\n",
                      "  authenticator: new IamAuthenticator({\n",
                      "    apikey: process.env.CIS_SERVICES_APIKEY,\n",
                      "  }),\n",
                      "  crn: process.env.CRN,\n",
                      "  zoneIdentifier: process.env.ZONE_ID,\n",
                      "  serviceUrl: process.env.API_ENDPOINT,\n",
                      "  version: '1',\n",
                      "};\n",
                      "\n",
                      "const rulesetsV1 = new RulesetsV1(options);\n",
                      "\n",
                      "rulesetsV1.getZoneRulesets()\n",
                      "  .then(response => {\n",
                      "    const { result } = response || {};\n",
                      "    console.log('Zone rulesets:\n', JSON.stringify(result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.error('Error fetching zone rulesets:\n', err);\n",
                      "  });\n"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "try {\n",
                      "  GetZoneRulesetsOptions getZoneRulesetsOptions = new GetZoneRulesetsOptions.Builder().build();\n",
                      "\n",
                      "  Response<ListRulesetsResp> response = service.getZoneRulesets(getZoneRulesetsOptions).execute();\n",
                      "  ListRulesetsResp result = response.getResult();\n",
                      "\n",
                      "  for (Ruleset ruleset : result.getResult()) {\n",
                      "    System.out.println(\"Ruleset ID: \" + ruleset.getId());\n",
                      "    System.out.println(\"Name: \" + ruleset.getName());\n",
                      "    System.out.println(\"Phase: \" + ruleset.getPhase());\n",
                      "    System.out.println(\"Version: \" + ruleset.getVersion());\n",
                      "    System.out.println(\"------\");\n",
                      "  }\n",
                      "\n",
                      "} catch (ServiceResponseException e) {\n",
                      "  System.err.printf(\"Service returned status code %d: %s\\nError details: %s\\n\",\n",
                      "    e.getStatusCode(), e.getMessage(), e.getDebuggingInfo());\n",
                      "}\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/zones/{zone_identifier}/rulesets/{ruleset_id}": {
      "get": {
        "tags": [
          "Zone Rulesets"
        ],
        "summary": "Get a zone ruleset",
        "operationId": "get_zone_ruleset",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.security.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.zone-rulesets.read"
            }
          ]
        },
        "description": "View a specific zone ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/zone_identifier"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ruleset_resp"
                },
                "examples": {
                  "response": {
                    "value": {
                      "result": {
                        "description": "updated description",
                        "id": "1b7f639a68c84184a76deb59ce4c618e",
                        "kind": "zone",
                        "last_updated": "2025-10-05T18:29:54.397532Z",
                        "name": "my-custom-ruleset",
                        "phase": "http_request_firewall_custom",
                        "rules": [
                          {
                            "action": "block",
                            "description": "Block traffic from IP 192.0.2.1",
                            "enabled": true,
                            "expression": "ip.src == 192.0.2.1",
                            "id": "73f8b4b296a34285b4d638ac110291c9",
                            "last_updated": "2025-10-05T18:12:46.865395Z",
                            "ref": "73f8b4b296a34285b4d638ac110291c9",
                            "version": "1"
                          },
                          {
                            "action": "block",
                            "description": "Block specific IP",
                            "enabled": true,
                            "expression": "ip.src == 192.0.2.1",
                            "id": "be24069f34904fe28ae1dd734f982f43",
                            "last_updated": "2025-10-05T18:19:48.156251Z",
                            "ref": "be24069f34904fe28ae1dd734f982f43",
                            "version": "1"
                          }
                        ],
                        "source": "firewall_custom",
                        "version": "12"
                      },
                      "success": true,
                      "errors": [],
                      "messages": []
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/zones/$ZONE_ID/rulesets/$RULESET_ID \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "package main\n",
                      "\n",
                      "import (\n",
                      "    \"encoding/json\"\n",
                      "    \"fmt\"\n",
                      "    \"os\"\n",
                      "\n",
                      "    \"github.com/IBM/go-sdk-core/v5/core\"\n",
                      "    \"github.com/IBM/networking-go-sdk/rulesetsv1\"\n",
                      ")\n",
                      "\n",
                      "func main() {\n",
                      "    authenticator := &core.IamAuthenticator{\n",
                      "        ApiKey: os.Getenv(\"CIS_SERVICES_APIKEY\"),\n",
                      "        URL:    os.Getenv(\"CIS_SERVICES_AUTH_URL\"),\n",
                      "    }\n",
                      "    serviceURL := os.Getenv(\"API_ENDPOINT\")\n",
                      "    crn := os.Getenv(\"CRN\")\n",
                      "    zoneID := os.Getenv(\"ZONE_ID\")\n",
                      "    rulesetID := os.Getenv(\"RULESET_ID\")\n",
                      "    options := &rulesetsv1.RulesetsV1Options{\n",
                      "        ServiceName:    \"cis_services\",\n",
                      "        URL:            serviceURL,\n",
                      "        Authenticator:  authenticator,\n",
                      "        Crn:            &crn,\n",
                      "        ZoneIdentifier: &zoneID,\n",
                      "    }\n",
                      "    service, serviceErr := rulesetsv1.NewRulesetsV1(options)\n",
                      "    if serviceErr != nil {\n",
                      "        fmt.Printf(\"Error creating RulesetsV1 service: %v\\n\", serviceErr)\n",
                      "        return\n",
                      "    }\n",
                      "    getRulesetOptions := &rulesetsv1.GetZoneRulesetOptions{\n",
                      "        RulesetID: core.StringPtr(rulesetID),\n",
                      "    }\n",
                      "    _, response, err := service.GetZoneRuleset(getRulesetOptions)\n",
                      "    if err != nil {\n",
                      "        fmt.Printf(\"Error retrieving ruleset: %v\\n\", err)\n",
                      "        return\n",
                      "    }\n",
                      "\n",
                      "    // fmt.Printf(\"Rulesets: %+v\\n\", result.Result)\n",
                      "    jsonBytes, err := json.MarshalIndent(response.Result, \"\", \"  \")\n",
                      "    if err != nil {\n",
                      "        fmt.Printf(\"Error marshaling ruleset: %v\\n\", err)\n",
                      "        return\n",
                      "    }\n",
                      "    fmt.Println(string(jsonBytes))\n",
                      "}\n"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "require('dotenv').config();\n",
                      "\n",
                      "const RulesetsV1 = require('ibm-networking-services/cis/rulesets/v1');\n",
                      "const { IamAuthenticator } = require('ibm-cloud-sdk-core');\n",
                      "\n",
                      "const options = {\n",
                      "  authenticator: new IamAuthenticator({\n",
                      "    apikey: process.env.CIS_SERVICES_APIKEY,\n",
                      "  }),\n",
                      "  crn: process.env.CRN,\n",
                      "  zoneIdentifier: process.env.ZONE_ID,\n",
                      "  serviceUrl: process.env.API_ENDPOINT,\n",
                      "  version: '1',\n",
                      "};\n",
                      "\n",
                      "const rulesetsV1 = new RulesetsV1(options);\n",
                      "\n",
                      "const params = {\n",
                      "  rulesetId: process.env.RULESET_ID,\n",
                      "};\n",
                      "\n",
                      "rulesetsV1.getZoneRuleset(params)\n",
                      "  .then(response => {\n",
                      "    const { result } = response || {};\n",
                      "    console.log('Zone ruleset:\\n', JSON.stringify(result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.error('Error retrieving zone ruleset:\\n', err);\n",
                      "  });\n"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "try {\n",
                      "  GetZoneRulesetOptions getZoneRulesetOptions = new GetZoneRulesetOptions.Builder()\n",
                      "    .rulesetId(\"55f63c45eb124c38b9a86c401d5f22d3\")\n",
                      "    .build();\n",
                      "\n",
                      "  Response<RulesetResp> response = service.getZoneRuleset(getZoneRulesetOptions).execute();\n",
                      "  RulesetResp result = response.getResult();\n",
                      "\n",
                      "  System.out.println(\"Ruleset ID: \" + result.getResult().getId());\n",
                      "  System.out.println(\"Name: \" + result.getResult().getName());\n",
                      "  System.out.println(\"Phase: \" + result.getResult().getPhase());\n",
                      "  System.out.println(\"Version: \" + result.getResult().getVersion());\n",
                      "\n",
                      "} catch (ServiceResponseException e) {\n",
                      "  System.err.printf(\"Service returned status code %d: %s\\nError details: %s\\n\",\n",
                      "    e.getStatusCode(), e.getMessage(), e.getDebuggingInfo());\n",
                      "}\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "put": {
        "tags": [
          "Zone Rulesets"
        ],
        "summary": "Update a zone ruleset",
        "operationId": "update_zone_ruleset",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.security.manage"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.zone-rulesets.update"
            }
          ]
        },
        "description": "Update a specific zone ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/zone_identifier"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          }
        ],
        "requestBody": {
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ruleset_update"
              },
              "examples": {
                "response": {
                  "value": {
                    "success": true,
                    "errors": [],
                    "messages": [],
                    "result": {
                      "description": "Updated via Go SDK",
                      "id": "42bc007e051c4766a0793d52a45f6900",
                      "kind": "zone",
                      "last_updated": "2025-09-24T17:35:57.635515Z",
                      "name": "my-request-sanitizer",
                      "phase": "http_request_sanitize",
                      "version": "2",
                      "rules": null
                    }
                  }
                }
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ruleset_resp"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X PUT \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/zones/$ZONE_ID/rulesets/$RULESET_ID \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\\\n",
                      "  -d '{\"description\":\"My ruleset to execute managed rulesets\",\"kind\":\"root\",\"name\":\"My ruleset\",\"phase\":\"http_request_firewall_custom\",\"rules\":[{\"action\":\"block\",\"action_parameters\":{\"response\":{\"content\":\"{\\n  \\\"success\\\": false,\\n  \\\"error\\\": \\\"you have been blocked\\\"\\n}\",\"content_type\":\"application/json\",\"status_code\":400}},\"description\":\"Block when the IP address is not 1.1.1.1\",\"enabled\":true,\"expression\":\"ip.src ne 1.1.1.1\",\"id\":\"3a03d665bac047339bb530ecb439a90d\",\"logging\":{\"enabled\":true},\"ref\":\"my_ref\"}]}'\n"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "package main\n",
                      "\n",
                      "import (\n",
                      "    \"encoding/json\"\n",
                      "    \"fmt\"\n",
                      "    \"os\"\n",
                      "\n",
                      "    \"github.com/IBM/go-sdk-core/v5/core\"\n",
                      "    \"github.com/IBM/networking-go-sdk/rulesetsv1\"\n",
                      ")\n",
                      "\n",
                      "func main() {\n",
                      "    authenticator := &core.IamAuthenticator{\n",
                      "        ApiKey: os.Getenv(\"CIS_SERVICES_APIKEY\"),\n",
                      "        URL:    os.Getenv(\"CIS_SERVICES_AUTH_URL\"),\n",
                      "    }\n",
                      "    serviceURL := os.Getenv(\"API_ENDPOINT\")\n",
                      "    crn := os.Getenv(\"CRN\")\n",
                      "    zoneID := os.Getenv(\"ZONE_ID\")\n",
                      "    rulesetID := os.Getenv(\"RULESET_ID\")\n",
                      "    options := &rulesetsv1.RulesetsV1Options{\n",
                      "        ServiceName:    \"cis_services\",\n",
                      "        URL:            serviceURL,\n",
                      "        Authenticator:  authenticator,\n",
                      "        Crn:            &crn,\n",
                      "        ZoneIdentifier: &zoneID,\n",
                      "    }\n",
                      "    service, serviceErr := rulesetsv1.NewRulesetsV1(options)\n",
                      "    if serviceErr != nil {\n",
                      "        fmt.Fprintf(os.Stderr, \"Error creating RulesetsV1 service: %v\\n\", serviceErr)\n",
                      "        return\n",
                      "    }\n",
                      "    updateOptions := &rulesetsv1.UpdateZoneRulesetOptions{\n",
                      "        RulesetID:   core.StringPtr(rulesetID),\n",
                      "        Description: core.StringPtr(\"Updated via Go SDK\"),\n",
                      "    }\n",
                      "    _, response, err := service.UpdateZoneRuleset(updateOptions)\n",
                      "    if err != nil {\n",
                      "        fmt.Fprintf(os.Stderr, \"Error updating ruleset: %v\\n\", err)\n",
                      "        return\n",
                      "    }\n",
                      "\n",
                      "    fmt.Printf(\"UpdateZoneRuleset() response : %v\\n\", response.Result)\n",
                      "}\n"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "require('dotenv').config();\n",
                      "\n",
                      "const RulesetsV1 = require('ibm-networking-services/cis/rulesets/v1');\n",
                      "const { IamAuthenticator } = require('ibm-cloud-sdk-core');\n",
                      "\n",
                      "const options = {\n",
                      "  authenticator: new IamAuthenticator({\n",
                      "    apikey: process.env.CIS_SERVICES_APIKEY,\n",
                      "  }),\n",
                      "  crn: process.env.CRN,\n",
                      "  zoneIdentifier: process.env.ZONE_ID,\n",
                      "  serviceUrl: process.env.API_ENDPOINT,\n",
                      "  version: '1',\n",
                      "};\n",
                      "\n",
                      "const rulesetsV1 = new RulesetsV1(options);\n",
                      "\n",
                      "const params = {\n",
                      "  rulesetId: process.env.RULESET_ID,\n",
                      "  description: 'Updated description for the ruleset',\n",
                      "  kind: 'zone',\n",
                      "  phase: 'http_request_firewall_custom',\n",
                      "  rules: [\n",
                      "    {\n",
                      "      action: 'block',\n",
                      "      expression: 'ip.src == 192.0.2.100',\n",
                      "      description: 'Block traffic from a test IP',\n",
                      "      enabled: true,\n",
                      "    }\n",
                      "  ],\n",
                      "};\n",
                      "\n",
                      "rulesetsV1.updateZoneRuleset(params)\n",
                      "  .then(response => {\n",
                      "    const { result } = response || {};\n",
                      "    console.log('Ruleset updated successfully:\\n', JSON.stringify(result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.error('Error updating ruleset:\\n', err);\n",
                      "  });\n"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "try {\n",
                      "  List<Rule> rules = new ArrayList<>();\n",
                      "  rules.add(new Rule.Builder()\n",
                      "    .id(\"df8f96e8baea4e14a03e1b04d7d5df22\")\n",
                      "    .action(\"block\")\n",
                      "    .expression(\"(http.request.uri.path contains \\\"/admin\\\")\")\n",
                      "    .enabled(true)\n",
                      "    .description(\"Block admin access\")\n",
                      "    .build());\n",
                      "\n",
                      "  UpdateZoneRulesetOptions updateZoneRulesetOptions = new UpdateZoneRulesetOptions.Builder()\n",
                      "    .rulesetId(\"55f63c45eb124c38b9a86c401d5f22d3\")\n",
                      "    .name(\"Updated ruleset name\")\n",
                      "    .description(\"Updated description for ruleset\")\n",
                      "    .phase(\"http_request_firewall_custom\")\n",
                      "    .kind(\"zone\")\n",
                      "    .rules(rules)\n",
                      "    .build();\n",
                      "\n",
                      "  Response<RulesetResp> response = service.updateZoneRuleset(updateZoneRulesetOptions).execute();\n",
                      "  RulesetResp result = response.getResult();\n",
                      "\n",
                      "  System.out.println(\"Updated ruleset ID: \" + result.getResult().getId());\n",
                      "  System.out.println(\"Updated ruleset name: \" + result.getResult().getName());\n",
                      "\n",
                      "} catch (ServiceResponseException e) {\n",
                      "  System.err.printf(\"Service returned status code %d: %s\\nError details: %s\\n\",\n",
                      "    e.getStatusCode(), e.getMessage(), e.getDebuggingInfo());\n",
                      "}\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      },
      "delete": {
        "tags": [
          "Zone Rulesets"
        ],
        "summary": "Delete a zone ruleset",
        "operationId": "delete_zone_ruleset",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.security.manage"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.zone-rulesets.delete"
            }
          ]
        },
        "description": "Delete a specific zone ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/zone_identifier"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          }
        ],
        "responses": {
          "204": {
            "description": "Success"
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X DELETE \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/zones/$ZONE_ID/rulesets/$RULESET_ID \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n",
                      "  -H 'x-auth-user-token: Bearer xxxxxx'\n"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "package main\n",
                      "\n",
                      "import (\n",
                      "    \"encoding/json\"\n",
                      "    \"fmt\"\n",
                      "    \"os\"\n",
                      "\n",
                      "    \"github.com/IBM/go-sdk-core/v5/core\"\n",
                      "    \"github.com/IBM/networking-go-sdk/rulesetsv1\"\n",
                      ")\n",
                      "\n",
                      "func main() {\n",
                      "    authenticator := &core.IamAuthenticator{\n",
                      "        ApiKey: os.Getenv(\"CIS_SERVICES_APIKEY\"),\n",
                      "        URL:    os.Getenv(\"CIS_SERVICES_AUTH_URL\"),\n",
                      "    }\n",
                      "    serviceURL := os.Getenv(\"API_ENDPOINT\")\n",
                      "    crn := os.Getenv(\"CRN\")\n",
                      "    zoneID := os.Getenv(\"ZONE_ID\")\n",
                      "    rulesetID := os.Getenv(\"RULESET_ID\")\n",
                      "\n",
                      "    options := &rulesetsv1.RulesetsV1Options{\n",
                      "        ServiceName:    \"cis_services\",\n",
                      "        URL:            serviceURL,\n",
                      "        Authenticator:  authenticator,\n",
                      "        Crn:            &crn,\n",
                      "        ZoneIdentifier: &zoneID,\n",
                      "    }\n",
                      "    service, err := rulesetsv1.NewRulesetsV1(options)\n",
                      "    if err != nil {\n",
                      "        fmt.Printf(\"Error creating RulesetsV1 service: %v\\n\", err)\n",
                      "        return\n",
                      "    }\n",
                      "\n",
                      "    deleteOptions := service.NewDeleteZoneRulesetOptions(rulesetID)\n",
                      "    response, err := service.DeleteZoneRuleset(deleteOptions)\n",
                      "    if err != nil {\n",
                      "        fmt.Printf(\"Error deleting ruleset: %v\\n\", err)\n",
                      "        return\n",
                      "    }\n",
                      "\n",
                      "    fmt.Println(response)\n",
                      "    jsonBytes, err := json.MarshalIndent(response, \"\", \"  \")\n",
                      "    if err != nil {\n",
                      "        fmt.Fprintf(os.Stderr, \"Error marshaling response: %v\\n\", err)\n",
                      "        return\n",
                      "    }\n",
                      "    fmt.Println(string(jsonBytes))\n",
                      "}\n"
                    ]
                  }
                ]
              }
            ],
            "node": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "require('dotenv').config();\n",
                      "\n",
                      "const RulesetsV1 = require('ibm-networking-services/cis/rulesets/v1');\n",
                      "const { IamAuthenticator } = require('ibm-cloud-sdk-core');\n",
                      "\n",
                      "const rulesetsV1 = new RulesetsV1({\n",
                      "  authenticator: new IamAuthenticator({ apikey: process.env.CIS_SERVICES_APIKEY }),\n",
                      "  crn: process.env.CRN,\n",
                      "  zoneIdentifier: process.env.ZONE_ID,\n",
                      "  serviceUrl: process.env.API_ENDPOINT,\n",
                      "  version: '1',\n",
                      "});\n",
                      "\n",
                      "const params = {\n",
                      "  rulesetId: process.env.RULESET_ID,\n",
                      "};\n",
                      "\n",
                      "rulesetsV1.deleteZoneRuleset(params)\n",
                      "  .then(response => {\n",
                      "    const { result } = response || {};\n",
                      "    console.log('Ruleset deleted successfully:\\n', JSON.stringify(result, null, 2));\n",
                      "  })\n",
                      "  .catch(err => {\n",
                      "    console.error('Error deleting ruleset:\\n', err);\n",
                      "  });\n"
                    ]
                  }
                ]
              }
            ],
            "java": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "try {\n",
                      "     DeleteZoneRulesetOptions options = new DeleteZoneRulesetOptions.Builder()\n",
                      "         .rulesetId(\"example-ruleset-id\")\n",
                      "         .build();\n",
                      "\n",
                      "     Response<Void> response = service.deleteZoneRuleset(options).execute();\n",
                      "     if (response.getStatusCode() == 204) {\n",
                      "         System.out.println(\"Zone ruleset deleted successfully.\");\n",
                      "     } else {\n",
                      "         System.out.println(\"Unexpected status code: \" + response.getStatusCode());\n",
                      "     }\n",
                      "} catch (ServiceResponseException e) {\n",
                      "     System.err.printf(\"Service returned status code %d: %s\\nError details: %s\\n\",\n",
                      "                       e.getStatusCode(), e.getMessage(), e.getDebuggingInfo());\n",
                      "}\n"
                    ]
                  }
                ]
              }
            ]
          }
        }
      }
    },
    "/v1/{crn}/zones/{zone_identifier}/rulesets/{ruleset_id}/versions": {
      "get": {
        "tags": [
          "Zone Rulesets"
        ],
        "summary": "List version of a zone ruleset",
        "operationId": "get_zone_ruleset_versions",
        "x-ibm-permissions": {
          "actions": [
            {
              "name": "internet-svcs.security.read"
            }
          ]
        },
        "x-ibm-events": {
          "events": [
            {
              "name": "internet-svcs.zone-rulesets-versions.read"
            }
          ]
        },
        "description": "List all versions of a specific zone ruleset.",
        "parameters": [
          {
            "$ref": "#/components/parameters/crn"
          },
          {
            "$ref": "#/components/parameters/zone_identifier"
          },
          {
            "$ref": "#/components/parameters/ruleset_id"
          }
        ],
        "responses": {
          "200": {
            "description": "Success",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/list_rulesets_resp"
                },
                "examples": {
                  "response": {
                    "value": {
                      "success": true,
                      "errors": [],
                      "messages": [],
                      "result": [
                        {
                          "description": "Created via Go SDK",
                          "id": "1b7f639a68c84184a76deb59ce4c618e",
                          "kind": "zone",
                          "last_updated": "2025-09-24T17:24:34.765Z",
                          "name": "my-custom-ruleset",
                          "phase": "http_request_firewall_custom",
                          "version": "1"
                        }
                      ]
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden! User has no privilege"
          },
          "404": {
            "description": "Resource not found"
          },
          "500": {
            "description": "Internal server error"
          }
        },
        "x-sdk-operations": {
          "request-examples": {
            "curl": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "curl -X GET \\\n",
                      "  https://api.cis.cloud.ibm.com/v1/$CRN/zones/$ZONE_ID/rulesets/$RULESET_ID/versions \\\n",
                      "  -H 'content-type: application/json' \\\n",
                      "  -H 'accept: application/json' \\\n"
                    ]
                  }
                ]
              }
            ],
            "go": [
              {
                "name": "Example request",
                "example": [
                  {
                    "type": "code",
                    "source": [
                      "package main\n",
                      "\n",
                      "import (\n",
                      "    \"encoding/json\"\n",
                      "    \"fmt\"\n",
                      "    \"os\"\n",
                      "\n",
                      "    \"github.com/IBM/go-sdk-core/v5/core\"\n",
                      "    \"github.com/IBM/networking-go-sdk/rulesetsv1\"\n",
                      ")\n",
                      "\n",
                      "func main() {\n",
[...]
